#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <unistd.h>
#include <string.h>

#include "main.h"
#include "liblist.h"

/*
static personne_t *personne_liste_hd = NULL;
static personne_t *personne_liste_ta = NULL;
*/
static personne_t *personne_liste;
static int personne_id = 0;
static int nb_arrives = 0;
extern char *arrets[NB_ARRETS];

extern int personnelog;
extern int personnelogflag;
FILE *plog;

static int changer_etat(int id, int etat)
{
  personne_t *pers;
  int i;
  
  list_foreach(personne_liste, pers, i)
    {
      if(pers->id == id)
	{
	  pers->etat = etat;
	  return 0;
	}
    }

  return -1;
}

static personne_t *trouver_personne(int id)
{
  int i;
  personne_t *p;

  list_foreach(personne_liste, p, i)
    {
      if(p->id == id)
	{
	  return p;
	}
    }
  return NULL;
}

/*
static int ajouter_personne(personne_t *p)
{
  if(personne_liste_ta == NULL)
    {
      personne_liste_ta = p;
      personne_liste_hd = p;
    }
  else
    {
      personne_liste_ta->next = p;
      p->prev = personne_liste_ta;
      personne_liste_ta = p;
    }
}

static int supprimer_personne(personne_t *p)
{
  personne_t *tmp;

  if(p->prev)
    p->prev->next = p->next;
  else
    personne_liste_hd = p->next;

  if(p->next)
    p->next->prev = p->prev;
  else
    personne_liste_ta = p->prev;

  free(p);
  
  return 0;
}
*/

static int gestion_personne(char *buffer)
{
  char depart[16], arrivee[16];
  int i, j;
  personne_t *pers;
  
  memset(depart, 0, sizeof(depart));
  memset(arrivee, 0, sizeof(arrivee));

  if(MAX_PERSONNE != 0 && personne_id > MAX_PERSONNE)
    {
      strcpy(buffer, "OK");
      return 0;
    }
  
  pers = malloc(sizeof(personne_t));
  if(pers == NULL)
    return -1;

  pers->id = personne_id++;
  pers->etat = EN_ATTENTE;
  pers->heure_depart = time(NULL);

  /* Extraction de l'arret de depart */
  for (i = 9, j = 0; buffer[i] != '-'; i++, j++)
    depart[j] = buffer[i];
  pers->depart = atoi(depart);
  
  /* On passe le '-' */
  i++;
  for (j = 0; buffer[i] != '\0'; i++, j++)
    arrivee[j] = buffer[i];
  pers->arrivee = atoi(arrivee);

  calculer_changements(pers);

  //  ajouter_personne(pers);
  list_add_tail(personne_liste, pers);

  strcpy(buffer, "OK");

  return 0;
}

static int gestion_bus(char *buffer)
{
  int bus, ligne, arret, sens, nb_passagers;
  char tmp[16];
  int i,j;
  personne_t *pers;

  /* Extraction du numero de bus */
  memset(tmp, 0, sizeof(tmp));
  for (i = 4, j = 0; buffer[i] != '-'; i++, j++)
    {
      tmp[j] = buffer[i];
    }
  bus = atoi(tmp);
  i++;

  /* Extraction du numero de ligne */
  memset(tmp, 0, sizeof(tmp));
  for (j = 0; buffer[i] != '-'; i++, j++)
    {
      tmp[j] = buffer[i];
    }
  ligne = atoi(tmp);
  i++;

  /* Extraction du numero d'arret */
  memset(tmp, 0, sizeof(tmp));
  for(j = 0; buffer[i] != '-'; i++, j++)
    {
      tmp[j] = buffer[i];
    }
  arret = atoi(tmp);
  i++;

  /* Extraction du sens */
  memset(tmp, 0, sizeof(tmp));
  for(j = 0; buffer[i] != '-'; i++, j++)
    {
      tmp[j] = buffer[i];
    }
  sens = atoi(tmp);

  /* Extraction du nombre de places */
  memset(tmp, 0, sizeof(tmp));
  for(j = 0; buffer[i] != ';'; i++, j++)
    {
      tmp[j] = buffer[i];
    }
  nb_passagers = atoi(tmp);
  

  /* Extraction des personnes qui sont descendues */
  i++;
  while(buffer[i] != '\0')
    {
      int id;
      personne_t *p;

      memset(tmp, 0, sizeof(tmp));

      for (j = 0; buffer[i] != ',' && buffer[i] != '\0'; j++, i++)
	tmp[j] = buffer[i];
      
      id = atoi(tmp);

      if(changer_etat(id, EN_ATTENTE) != 0)
	erreur("Personne inconnue");
      
      p = trouver_personne(id);

      /* Log de toutes les personnes */
      if(personnelogflag != 0 && personnelog == -1)
	fprintf(plog, "Personne %d descend  %s (%d) du bus %d sur la ligne %d\n",
		p->id, arrets[arret], arret, bus, bus%5);
      /* Log d'une personne donnee */
      else if(personnelogflag != 0 && p->id == personnelog)
	fprintf(plog, "Descend  %s (%d) du bus %d sur la ligne %d\n",
		arrets[arret], arret, bus, bus%5);

      /* La personne est-elle arrivee ? */
      if(p->arrivee == p->liste_changement->num && p->etat == EN_ATTENTE)
	{
	  p->heure_arrivee = time(NULL);
	  printf("La personne %d partie de %d est arrivee a %d en %d\n", 
		 p->id, p->depart, p->arrivee, (int) (p->heure_arrivee-p->heure_depart));
	  nb_arrives++;

	  /* On supprime la personne de la liste des personnes */
	  /*
	  if(supprimer_personne(p) != 0)
	    erreur("Erreur lors de la suppression\n");
	  */
	  list_delete(personne_liste, p);
	  
	  /* Si on a un nombre maximum de personne et que l'on est
             arrive a ce nombre, on arrete tout */
	  if(nb_arrives == MAX_PERSONNE+1 && MAX_PERSONNE != 0)
	    {
	      killall();
	      exit(0);
	    }
	}

      if(buffer[i] != '\0')
	i++;
    }

  fflush(plog);

  /* Construction de la liste des personnes devant monter dans le bus */
  memset(buffer, 0, sizeof(buffer));
  strcpy(buffer, "OK-");

  list_foreach(personne_liste, pers, i)
    {
      changement_t *changement_tmp;
      char tmp[16];

      if(nb_passagers == 0)
	{
	  printf("Bus complet\n");
	  break;
	}

      if(pers->liste_changement->ligne == ligne &&
	 pers->liste_changement->num  == arret &&
	 pers->liste_changement->sens  == sens  &&
	 pers->etat == EN_ATTENTE)
	{
	  /* Log de toutes les personnes */
	  if(personnelogflag != 0 && personnelog == -1)
	    fprintf(plog, "Personne %d monte  %s (%d) dans le bus %d sur la ligne %d\n",
		    pers->id, arrets[arret], arret, bus, bus%5);
	  /* Log d'une personne donnee */
	  else if(personnelogflag != 0 && pers->id == personnelog)
	    fprintf(plog, "Monte  %s (%d) du bus %d sur la ligne %d\n",
		    arrets[arret], arret, bus, bus%5);

	  changement_tmp = pers->liste_changement;
	  list_delete(pers->liste_changement, changement_tmp);
	  free(changement_tmp);
	  
	  snprintf(tmp, sizeof(tmp), "%d,%d;", 
		   pers->id, pers->liste_changement->num);
	  strcat(buffer, tmp);
	  pers->etat = EN_ROUTE;
	  nb_passagers--;
	}
    }
  
  fflush(plog);
  if(buffer[strlen(buffer)-1] == ';')
    buffer[strlen(buffer)-1] = '\0';

  //  printf("Gestionnaire->Bus [%d] : %s\n", bus, buffer);

  return 0;
}

int gestionnaire(fd_set *set, int max_fd)
{
  fd_set set2;
  int i;

  if(personnelogflag != 0)
    {
      plog = fopen("personne.log", "w");
      if(plog == NULL)
	erreur("Erreur lors de l'ouverture du log personne\n");
    }

  while(1)
    {
      /* N'utilise pas directement 'set' mais 'set2' */
      memcpy(&set2, set, sizeof(fd_set));
      
      select(max_fd+1, &set2, NULL, NULL, NULL);
      
      for(i = 0; i < max_fd+1; i++)
	{
	  if(FD_ISSET(i, &set2))
	    {
	      int j, k;
	      char buffer[256];

	      /* On cherche quel processus nous a envoye
		 un message */
	      for (j = 0; j < FD_NB; j++)
		if(fdin[j][0] == i)
		  break;

	      /* Lecture du message */
	      k = 0;
	      do
		{
		  read(i, buffer + k, 1);
		  k++;
		} while(buffer[k-1] != '\0');

	      if(!strncmp(buffer, "BUS", 3))
		{
		  gestion_bus(buffer);
		}
	      else if(!strncmp(buffer, "PERSONNE", 8))
		{
		  gestion_personne(buffer);
		}
	      else
		{
		  printf("OUPPPS : %s\n", buffer);
		}
	      
	      /* Envoi de la confirmation */
	      write(fdout[j][1], buffer, strlen(buffer)+1);
	      memset(buffer, 0, sizeof(buffer));
	    }
	}
    }
}
