#ifndef __MAIN_H__
#define __MAIN_H__

#include <sys/types.h>
#include <time.h>

#define NB_ARRETS_FLOAT 21.0
#define NB_ARRETS ((int) NB_ARRETS_FLOAT)
#define NB_LIGNES 5

/* Nombre de bus */
#define BUS_NB (NB_LIGNES*1)

/* Nous avons besoin de BUS_NB tubes + un autre tube pour dialoguer
   avec le processus personne */
#define FD_NB  BUS_NB+1


#define FORWARD 0
#define BACKWARD 1

#define MAX_PASSAGER 30
#define MAX_PERSONNE 100

typedef struct personne 
{
  int id;
  int depart;
  int arrivee;
  time_t heure_depart;
  time_t heure_arrivee;
  enum { EN_ROUTE, EN_ATTENTE } etat;
  struct changement *liste_changement;
  struct personne *prev;
  struct personne *next;
} personne_t;

typedef struct changement
{
  int num; /* numero de l'arret */
  int ligne; /* numero de ligne */
  int sens;
  struct changement *next, *prev;
} changement_t;

#define RAND(max) ((int) ((max)*rand()/(RAND_MAX+1.0)))

extern int fdin[FD_NB][2];
extern int fdout[FD_NB][2];
extern int lignes[5][7];

void killall();

int erreur(char *str);
int bus(int line, int bus_nb);
int gestionnaire(fd_set *set, int max_fd);
int generateur_personne(void);
int reseau_init();
void calculer_changements(personne_t *personne);
void perturbateur();

#endif
